
	list      p=16f870
	#include <p16f870.inc>
	
	__CONFIG _CP_OFF & _WDT_OFF & _BODEN_OFF & _PWRTE_ON & _XT_OSC & _WRT_ENABLE_ON & _LVP_OFF & _CPD_OFF

flag	equ	20h	; flag registar
setleds	equ	0	; 0 = do not set leds, 1 = set leds
glbro	equ	21h	; glavni brojac do 250 za 1 sec
hour	equ	22h	; sat                  0...11
min10	equ	23h	; 10 minuta            0...5
min	equ	24h	; minut                0...9
sec10	equ	25h	; 10 sekundi           0...5
sec	equ	26h	; sekund               0...9
debo1	equ	27h	; rotor za debouncing za donji taster
debo2	equ	28h	; rotor za debouncing za gornji taster

start
	movlw	20h
	movwf	fsr
clram
	clrf	indf		; brise interni RAM od 20h do 3fh
	incf	fsr,f
	btfss	fsr,6
	goto	clram

	movlw	0ffh
	movwf	porta
	movwf	portb
	movwf	portc

	bsf	status,rp0
	movlw	83h		; prescaler 1:16 to timer0, no pullups
	movwf	option_reg
	movlw	20h		; port a: bits 01234 outputs
	movwf	trisa
	movlw	80h		; port b: bits 0123456 outputs
	movwf	trisb
	movwf	trisc		; port c: bits 0123456 outputs
	bcf	status,rp0
	goto	farm2
farm
	btfss	flag,setleds
	goto	noshow
farm2				; pokazi vreme (set leds) --------------------
	bcf	flag,setleds
	
	swapf	sec10,w
	andlw	0f0h		; sec10 = hi nibble
	iorwf	sec,w
	xorlw	7fh
	movwf	portc		; display secs

	swapf	min10,w
	andlw	0f0h		; min10 = hi nibble
	iorwf	min,w
	xorlw	7fh
	movwf	portb		; display mins

	movf	hour,w
	bz	show12h		; treat 0h as 12h
	addlw	-.10
	movf	hour,w
	bnc	showh		; display 1h...9h
	addlw	.6		; bcd adjust w
	goto	showh		; display 10h or 11h
show12h				; display 12h
	movlw	12h
showh				; display hours
	xorlw	1fh
	movwf	porta
noshow				; --------------------------------------------
	btfss	intcon,t0if
	goto	noshow
				; 4 ms (250 Hz) tick here
	bcf	intcon,t0if
				; test keys
	rlf	portb,w
	rlf	debo1,f		; donji taster (minuti)
	movf	debo1,w
	addlw	2
	bnz	nojustmin
				; upravo pritisnut donji taster (minuti)
	clrf	sec
	clrf	sec10

	incf	min,f
	movlw	-.10
	addwf	min,w
	bnc	nomin0

	clrf	min
	incf	min10,f
	movlw	-.6
	addwf	min10,w
	bnc	nomin0
	clrf	min10
nomin0
	bsf	flag,setleds
	goto	nokeys
nojustmin
	rlf	portc,w
	rlf	debo2,f		; gornji taster (sati)
	movf	debo2,w
	addlw	2
	bnz	nokeys
				; upravo pritisnut gornji taster (sati)
	incf	hour,f
	movlw	-.12
	addwf	hour,w
	bnc	noh0
	clrf	hour
noh0
	bsf	flag,setleds
nokeys				; ------------------------------------------
	decf	glbro,f
	bnz	farm		; not 1 sec yet
				; 1 sec tick here
	movlw	.250
	movwf	glbro
				; inc sec
	incf	sec,f
	movlw	-.10
	addwf	sec,w
	bnc	farm2
				; inc sec10
	clrf	sec
	incf	sec10,f
	movlw	-.6
	addwf	sec10,w
	bnc	farm2
				; inc min
	clrf	sec10
	incf	min,f
	movlw	-.10
	addwf	min,w
	bnc	farm2
				; inc min10
	clrf	min
	incf	min10,f
	movlw	-.6
	addwf	min10,w
	bnc	farm2
				; inc hour
	clrf	min10
	incf	hour,f
	movlw	-.12
	addwf	hour,w
	bnc	farm2
				; midnight
	clrf	hour
	goto	farm2

	end
